%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculates the combined B matrix for controllable inputs
%
% @author Andrea Angioni <aangioni@eonerc.rwth-aachen.de>
% @copyright 2018, Institute for Automation of Complex Power Systems, EONERC
% @license GNU General Public License (version 3)
%
% Statespacemodeldistribution
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program.  If not, see <http://www.gnu.org/licenses/>.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function B_input = def_B_input(DM)
Gx = 0;
if sum(DM.grid_supp_PV) > 0
    Gx = 1;
end
B_input  = zeros (11*DM.NGF+10*DM.NGS + 2*DM.Nload + 2*DM.PCC + 2*DM.Nline,2*DM.PCC + Gx +2*sum(DM.grid_supp_PQ) + DM.NGF);

if DM.PCC == 1
    B_input( 11*DM.NGF+10*DM.NGS+ 2*DM.Nload + 1, 1) = 1/DM.Lcc;
    B_input( 11*DM.NGF+10*DM.NGS+ 2*DM.Nload + 2, 2) = 1/DM.Lcc;
end
if Gx == 1
    for x = 1 : DM.Nnode
        if DM.grid_supp_PV(x)==1
            if x ~= DM.ref
                B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                    11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+10,2*DM.PCC+1)=[...
                    0;...
                    0;...
                    DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2);...
                    DM.PF(x)*DM.Pmax(x);...
                    DM.Pmax(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2);...
                    DM.PF(x)*DM.Pmax(x)*DM.kpv_q(x);...
                    (DM.Pmax(x)*DM.kpc_d(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2))/DM.Lf(x);...
                    (DM.PF(x)*DM.Pmax(x)*DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x);...
                    0;...
                    0;...
                    ];
            else
                B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                    11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+10,2*DM.PCC+1)=[...
                    0;...
                    0;...
                    DM.Pmax(x)*(1 - DM.PF(x)^2)^(1/2);...
                    DM.PF(x)*DM.Pmax(x);...
                    DM.Pmax(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2);...
                    DM.PF(x)*DM.Pmax(x)*DM.kpv_q(x);...
                    (DM.Pmax(x)*DM.kpc_d(x)*DM.kpv_d(x)*(1 - DM.PF(x)^2)^(1/2))/DM.Lf(x);...
                    (DM.PF(x)*DM.Pmax(x)*DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x);...
                    0;...
                    0;...
                    ];
            end
        end
    end %contribution G
end

if sum(DM.grid_supp_PQ) > 0
    for x = 1 : DM.Nnode
        if DM.grid_supp_PQ(x) == 1
            if x ~= DM.ref
                B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                    11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+10,2*DM.PCC+Gx + 2*sum(DM.grid_supp_PQ(1:x-1))+1:...
                    2*DM.PCC+Gx + 2*sum(DM.grid_supp_PQ(1:x-1))+2)=[...
                    0, 0;...
                    0, 0;...
                    0, 1;...
                    1, 0;...
                    0, DM.kpv_d(x);...
                    DM.kpv_q(x), 0;...
                    0, (DM.kpc_d(x)*DM.kpv_d(x))/DM.Lf(x);...
                    (DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x), 0;...
                    0, 0;...
                    0, 0;...
                    ];
            else
                B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                    11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+10,2*DM.PCC+Gx + 2*sum(DM.grid_supp_PQ(1:x-1))+1:...
                    2*DM.PCC+Gx + 2*sum(DM.grid_supp_PQ(1:x-1))+2)=[...
                    0, 0;...
                    0, 0;...
                    0, 1;...
                    1, 0;...
                    0, DM.kpv_d(x);...
                    DM.kpv_q(x), 0;...
                    0, (DM.kpc_d(x)*DM.kpv_d(x))/DM.Lf(x);...
                    (DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x), 0;...
                    0, 0;...
                    0, 0;...
                    ];
            end
        end
    end
end



for x = 1 : DM.Nnode
    if DM.grid_form(x) == 1
        if x ~= DM.ref
            B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+11, 2*DM.PCC + Gx +2*sum(DM.grid_supp_PQ)  +  sum(DM.grid_form(1:x-1))+1)=[...
                0,...
                0,...
                0,...
                0,...
                1,...
                0,...
                DM.kpv_q(x),...
                0,...
                (DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x),...
                0,...
                0
                ];%contribution Voqn
            
        else
            B_input(11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+1:...
                11*sum(DM.grid_form(1:x-1))+10*sum(DM.grid_supp(1:x-1))+11,2*DM.PCC + Gx +2*sum(DM.grid_supp_PQ) + sum(DM.grid_form(1:x-1))+1)=[...
                0,...
                0,...
                0,...
                0,...
                1,...
                0,...
                DM.kpv_q(x),...
                0,...
                (DM.kpc_q(x)*DM.kpv_q(x))/DM.Lf(x),...
                0,...
                0
                ];%contribution Voqn
        end
    end
end

end